/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.MenuBar;


public class Applet extends Widget {
    private attribute applet:<<javax.swing.JApplet>>;
    public attribute menubar: MenuBar?;
    public attribute content: Widget;
    public operation showDocument(url:String);
    public operation showDocumentInFrame(url:String, frameName:String);
}

APPLICATION:Applet = Applet {
};

operation Applet.showDocument(url:String) {
    this.showDocumentInFrame(url, "_self");
}

operation Applet.showDocumentInFrame(url:String, frameName:String) {
    if (applet <> null) {
        applet.getAppletContext().showDocument(new <<java.net.URL>>(url),
                                               frameName);
    }
}

trigger on (new Applet) {
    applet = context:<<net.java.javafx.ui.UIContext>>.getApplet();
    APPLICATION:Applet = this;
}

operation Applet.getWindow() {
    return <<javax.swing.SwingUtilities>>.getWindowAncestor(applet);
}

trigger on (Applet.menubar = value) {
    applet.setJMenuBar(value.jmenubar);
}

trigger on (Applet.content = w) {
    applet.setContentPane(w.getComponent());
}
