/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
//import javafx.ui.Widget;

public class BorderPanel extends Widget {
    private attribute jpanel: <<javax.swing.JPanel>>;
    public attribute top:Widget?;
    public attribute left:Widget?;
    public attribute bottom:Widget?;
    public attribute right:Widget?;
    public attribute center:Widget?;
}

attribute BorderPanel.focusable = false;

operation BorderPanel.createComponent():<<javax.swing.JComponent>> {
    jpanel = context:<<net.java.javafx.ui.UIContext>>.createPanel();
    jpanel.setOpaque(false);
    var layout = new <<java.awt.BorderLayout>>();
    jpanel.setLayout(layout);
    if (top <> null) {
        jpanel.add(top.getComponent(), <<java.awt.BorderLayout>>.NORTH);
    }
    if (left <> null) {
        jpanel.add(left.getComponent(), <<java.awt.BorderLayout>>.WEST);
    }
    if (center <> null) {
        jpanel.add(center.getComponent(), <<java.awt.BorderLayout>>.CENTER);
    }
    if (bottom <> null) {
        jpanel.add(bottom.getComponent(), <<java.awt.BorderLayout>>.SOUTH);
    }
    if (right <> null) {
        jpanel.add(right.getComponent(), <<java.awt.BorderLayout>>.EAST);
    }
    return jpanel;
}


trigger on (BorderPanel.top[old] = value) {
    if (jpanel <> null) {
        if (old <> null) {
            jpanel.remove(old.getComponent());
        }
        if (value <> null) {
            jpanel.add(value.getComponent(), <<java.awt.BorderLayout>>.NORTH);
        }
        jpanel.revalidate();
        jpanel.repaint();
    }
}

trigger on (BorderPanel.left[old] = value) {
    if (jpanel <> null) {
        if (old <> null) {
            jpanel.remove(old.getComponent());
        }
        if (value <> null) {
            jpanel.add(value.getComponent(), <<java.awt.BorderLayout>>.WEST);
        }
        jpanel.revalidate();
        jpanel.repaint();
    }
}


trigger on (BorderPanel.bottom[old] = value) {
    if (jpanel <> null) {
        if (old <> null) {
            jpanel.remove(old.getComponent());
        }
        if (value <> null) {
            jpanel.add(value.getComponent(), <<java.awt.BorderLayout>>.SOUTH);
        }
        jpanel.revalidate();
        jpanel.repaint();
    }
}

trigger on (BorderPanel.right[old] = value) {
    if (jpanel <> null) {
        if (old <> null) {
            jpanel.remove(old.getComponent());
        }
        if (value <> null) {
            jpanel.add(value.getComponent(), <<java.awt.BorderLayout>>.EAST);
        }
        jpanel.revalidate();
        jpanel.repaint();
    }
}

trigger on (BorderPanel.center[old] = value) {
    if (jpanel <> null) {
        if (old <> null) {
            jpanel.remove(old.getComponent());
        }
        if (value <> null) {
            jpanel.add(value.getComponent(), <<java.awt.BorderLayout>>.CENTER);
        }
        jpanel.revalidate();
        jpanel.repaint();
    }
}
