/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;

public class CardPanel extends Widget {
    protected attribute selectionGeneration: Number;
    private attribute jpanel:<<javax.swing.JPanel>>;
    private attribute layout:<<java.awt.CardLayout>>;
    public attribute selection: Number;
    public attribute cards: Widget*;
}

attribute CardPanel.focusable = false;

operation CardPanel.createComponent():<<javax.swing.JComponent>> {
    jpanel = context:<<net.java.javafx.ui.UIContext>>.createPanel();
    layout = new <<java.awt.CardLayout>>();
    jpanel.setLayout(layout);
    jpanel.setOpaque(false);
    if (selection <> null) {
        var w = cards[selection];
        if (w <> null) {
            var comp = w.getComponent();
            var id = "{<<java.lang.System>>.identityHashCode(comp)}";
            jpanel.add(comp, id);
            layout.show(jpanel, id);
        }
    }
    return jpanel;
}

attribute CardPanel.selection = -1;

trigger on (new CardPanel) {
  //  this.getComponent();
}

trigger on (CardPanel.selection[old] = value) {
    if (value <> null and value >= 0) {
        var gen = ++selectionGeneration;
        do later {
            if (gen == selectionGeneration) {
                var w = cards[value];
                if (sizeof w > 0) {
                    var comp = w.getComponent();
                    var id = "{<<java.lang.System>>.identityHashCode(comp)}";
                    
                    if (comp.getParent() <> jpanel) {
                        jpanel.add(comp, id);
                        jpanel.validate();
                    }
                    layout.show(jpanel, id);
                }
            }
        }
    }
}

trigger on (insert w into CardPanel.cards) {
    if (component <> null and indexof w == selection) {
        var comp = w.getComponent();
        var id = "{<<java.lang.System>>.identityHashCode(comp)}";
        jpanel.add(comp, id);
        layout.show(jpanel, id);
        jpanel.validate();
        jpanel.repaint();
    }
}

trigger on (delete w from CardPanel.cards) {
    if (w.component <> null) {
        jpanel.remove(w.component);
    }
}
