/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

public class CenterPanel extends Widget {
    private operation replaceComponent(w:Widget);
    private attribute jpanel: <<javax.swing.JPanel>>;
    public attribute content: Widget?;
}

attribute CenterPanel.focusable = false;

operation CenterPanel.createComponent() {
    jpanel = new <<javax.swing.JPanel>>;
    jpanel.setOpaque(false);
    jpanel.setLayout(new <<java.awt.GridBagLayout>>());
    if (content <> null) {
        this.replaceComponent(content);
    }
    return jpanel;
}

trigger on CenterPanel.content = w {
    this.replaceComponent(w);
}

operation CenterPanel.replaceComponent(w:Widget) {
    var constraint = new <<java.awt.GridBagConstraints>>();
    constraint.anchor = CENTER:Anchor.id;
    constraint.fill = NONE:Fill.id;
    constraint.gridx = <<java.awt.GridBagConstraints>>.RELATIVE;
    constraint.gridy = <<java.awt.GridBagConstraints>>.RELATIVE;
    constraint.gridwidth = 1;
    constraint.gridheight = 1;
    constraint.weightx = 0;
    constraint.weighty = 0;
    constraint.ipadx = 0;
    constraint.ipady = 0;
    if (jpanel.componentCount > 0) {
        jpanel.remove(0);
    }
    jpanel.add(w.getComponent(), 
               constraint);
    jpanel.validate();
}
