/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.UIElement;
import javafx.ui.MessageType;
import javafx.ui.Icon;
import javax.swing.JOptionPane;

public class ConfirmDialog {
    public attribute owner: UIElement?;
    public attribute confirmType: ConfirmType;
    public attribute messageType: MessageType;
    public attribute icon: Icon?;
    public attribute title: String;
    public attribute message: String;
    public attribute visible: Boolean;
    public attribute onYes: operation();
    public attribute onNo: operation();
    public attribute onCancel: operation();
}

attribute ConfirmDialog.visible = false;
attribute ConfirmDialog.messageType = PLAIN:MessageType;
attribute ConfirmDialog.confirmType = DEFAULT:ConfirmType;

trigger on ConfirmDialog.visible = value {
    if (value) {
         do later {
            var result = JOptionPane.showConfirmDialog(owner.getWindow(),
                                                          message,
                                                          title,
                                                          confirmType.id,
                                                          messageType.id,
                                                          icon.getIcon());
	    if (result == JOptionPane.YES_OPTION) { (this.onYes)(); } 
            else if (result == JOptionPane.NO_OPTION) { (this.onNo)(); }
            else if (result == JOptionPane.CLOSED_OPTION) { (this.onCancel)(); }
            else if (result == JOptionPane.OK_OPTION) { (this.onYes)(); }
            else if (result == JOptionPane.CANCEL_OPTION) { (this.onCancel)(); }
            visible = false;
        }
    }
}
