/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import java.awt.Cursor as AWTCursor;
import java.awt.Toolkit;

public class Cursor {
    protected attribute awtCursor: AWTCursor;
    public operation getCursor(): AWTCursor;
    protected operation createCursor(): AWTCursor;
}

operation Cursor.getCursor() {
    if (awtCursor == null) {
        awtCursor = this.createCursor();
    }
    return awtCursor;
}


DEFAULT:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(DEFAULT_CURSOR) };
CROSSHAIR:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(CROSSHAIR_CURSOR)};
TEXT:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(TEXT_CURSOR)};
WAIT:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(WAIT_CURSOR)};
SW_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(SW_RESIZE_CURSOR)};
SE_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(SE_RESIZE_CURSOR)};
NW_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(NW_RESIZE_CURSOR)};
NE_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(NE_RESIZE_CURSOR)};
N_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(N_RESIZE_CURSOR)};
S_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(S_RESIZE_CURSOR)};
W_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(W_RESIZE_CURSOR)};
E_RESIZE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(E_RESIZE_CURSOR)};
HAND:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(HAND_CURSOR)};
MOVE:Cursor = Cursor { awtCursor: AWTCursor.getPredefinedCursor(MOVE_CURSOR)};

H_RESIZE:Cursor = W_RESIZE:Cursor;
V_RESIZE:Cursor = N_RESIZE:Cursor;
