/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import java.awt.Font as AWTFont;
import net.java.javafx.ui.UIContext;

public class Font {
    public attribute face: FontFace?;
    public attribute faceName: String?;
    public attribute size: Integer;
    public attribute style: FontStyle*;
    private attribute styleStr: String*;
    public operation getFont(): AWTFont;
    public operation Font(faceName:String, style:String*, size:Integer);
    private operation bigger(): Font;
    private operation smaller(): Font;
    private operation plain(): Font;
    private operation bold(): Font;
    private operation italic(): Font;
    private operation computeStyle(n:FontStyle*): Integer;
}

operation Font.Font(faceName:String, style:String*, size:Integer) {
    this.faceName = faceName;
    for (i in style) {
        if (i == "PLAIN") {
            insert PLAIN:FontStyle into this.style;
        } else if (i == "ITALIC") {
            insert ITALIC:FontStyle into this.style;
        } else if (i == "BOLD") {
            insert BOLD:FontStyle into this.style;
        } else {
            throw "Bad font style {i}: expected PLAIN, BOLD, or ITALIC";
        }
    }
    this.styleStr = style;
    this.size = size;
}

function Font.bigger() {
    return new Font(this.faceName, this.styleStr, this.size+1);
}

function Font.smaller() {
    return new Font(this.faceName, this.styleStr, this.size-1);
}

function Font.plain() {
    return new Font(this.faceName, "PLAIN", this.size);
}

function Font.bold() {
    return new Font(this.faceName, "BOLD", this.size);
}

function Font.italic() {
    return new Font(this.faceName, "ITALIC", this.size);
}

operation Font.computeStyle(n:FontStyle*) {
    var bits = 0;
    for (i in n) {
        bits = context:UIContext.setBit(bits, i.id);
    }
    return bits;
}

function Font.getFont() {
    var family = bind if face <> null then face.id else if faceName <> null then faceName else "Dialog"; 
    return if face.url <> null then context:UIContext.getFont(face.url, computeStyle(style), size) else new AWTFont(family, computeStyle(style), size);
}
