/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.canvas.Transformable;
import java.awt.Color as AWTColor;

public class Gradient extends AbstractColor, Transformable {
    /** The ramp of colors to use on this gradient */
    public attribute stops: Stop*;
    public attribute spreadMethod: SpreadMethod;
    public attribute gradientUnits: GradientUnits;
    protected attribute holders: StopHolder*;
    protected attribute stopCount: Number;
}

attribute Gradient.holders = bind foreach (s in stops ) {gradient: this, jstop: new <<net.java.javafx.ui.Stop>>(), offset: bind s.offset, color: bind s.color.getColor()};

class StopHolder {
    attribute gradient: Gradient;
    attribute jstop: <<net.java.javafx.ui.Stop>>;
    attribute offset: Number;
    attribute color: AWTColor;
}

trigger on StopHolder.offset = value {
    jstop.offset = value;
    gradient.stopCount++;
}

trigger on StopHolder.color = value {
    jstop.color = value;
    gradient.stopCount++;
}
