/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.GridCell;
import javafx.ui.Widget;

public class GridBagPanel extends Widget {
    private attribute jpanel: <<javax.swing.JPanel>>;

    public attribute cells: GridCell*;
}

attribute GridBagPanel.focusable = false;

operation GridBagPanel.createComponent(): <<javax.swing.JComponent>> {
    jpanel = new <<javax.swing.JPanel>>();
    jpanel.setOpaque(false);
    jpanel.setLayout(new <<java.awt.GridBagLayout>>());
    for (i in cells) {
        jpanel.add(i.content.getComponent(), i.constraint);
    }
    return jpanel;
}

trigger on (insert cell into GridBagPanel.cells) {
    if (jpanel <> null) {
        jpanel.add(cell.content.getComponent(), cell.constraint, indexof cell);
    }
}

trigger on (GridBagPanel.cells[oldCell] = cell) {
    if (jpanel <> null) {
        jpanel.remove(indexof oldCell);
        jpanel.add(cell.content.getComponent(), cell.constraint, indexof cell);
    }
}

trigger on (delete oldCell from GridBagPanel.cells) {
    if (jpanel <> null) {
        jpanel.remove(indexof oldCell);
    }
}
