/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.FlowLayout;


class InternalDialog extends InternalWindow {
    // private:
    operation updateButtons();
    attribute panel: JPanel;
    attribute buttonpanel: JPanel;
    attribute southPanel: JPanel;
    attribute centerPanel: JPanel;

    // public:
    attribute buttons: Button*;

}

trigger on (new InternalDialog) {
    panel = new JPanel();
    panel.setName("internalDialog.content");
    panel.setLayout(new BorderLayout());
    panel.setOpaque(false);
    buttonpanel = new <<javax.swing.JPanel>>();
    buttonpanel.setOpaque(false);
    var p = new JPanel();
    p.setLayout(new FlowLayout(FlowLayout.TRAILING));
    p.setBorder(new <<javax.swing.border.EmptyBorder>>(6, 0, 0, 0));
    p.add(buttonpanel);
    p.setOpaque(false);
    panel.add(p, <<java.awt.BorderLayout>>.SOUTH);
    southPanel = p;
    p = new JPanel();
    p.setOpaque(false);
    //p.setBorder(new <<net.java.javafx.ui.ShadowedBorder>>());
    centerPanel = new JPanel();
    centerPanel.setOpaque(false);
    centerPanel.setLayout(new BorderLayout());
    p.setLayout(new BorderLayout());
    centerPanel.setBorder(new <<javax.swing.border.EmptyBorder>>(4,4,4,4));
    p.add(centerPanel, BorderLayout.CENTER);
    panel.add(p, BorderLayout.CENTER);
    panel.setBorder(new <<javax.swing.border.EmptyBorder>>(6,6,6,6));
    resizable = false;
    anchor = CENTER;
}

operation InternalDialog.updateButtons() {
    while (buttonpanel.componentCount > 0) {
        buttonpanel.remove(0);
    }
    if (sizeof buttons == 0) {
        southPanel.remove(0);
    } else {
        if (sizeof buttons == 1) {
            southPanel.add(buttonpanel);
        }
        var builder = new <<com.jgoodies.forms.builder.ButtonBarBuilder>>(buttonpanel);
        var btns:<<javax.swing.JButton>>*;
        for (i in buttons) {
            insert (<<javax.swing.JButton>>)i.getComponent() into btns;
        }
        builder.addGriddedButtons(btns);
        southPanel.validate();
    }
}

trigger on (insert b into InternalDialog.buttons) {
    this.updateButtons();
}    

trigger on (delete b from InternalDialog.buttons) {
    this.updateButtons();
}

trigger on (InternalDialog.buttons[oldButton] = newButton) {
    this.updateButtons();
}

operation InternalDialog.onSetContent(w: Widget) {
    centerPanel.add(w.getComponent(),BorderLayout.CENTER);
    panel.validate();
    this.setContent(panel);
}
