/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javax.swing.event.*;

public class Label extends Widget {
    private attribute updateCount: Number;
    private attribute jlabel: <<net.java.javafx.ui.XLabel>>;
    public attribute text: String;
    public attribute honorDisplayProperties: Boolean;
    public attribute preloadImages: Boolean;
    public attribute onHyperlinkActivated: operation(url:String)?;
}

attribute Label.honorDisplayProperties = true;
attribute Label.focusable = false;

trigger on (Label.honorDisplayProperties = value) {
    jlabel.putClientProperty(jlabel.HONOR_DISPLAY_PROPERTIES, value);
}

operation Label.createComponent():<<javax.swing.JComponent>> {
    jlabel = context:<<net.java.javafx.ui.UIContext>>.createLabel();	
    var self = this;
    jlabel.addHyperlinkListener(new HyperlinkListener() {
	    operation hyperlinkUpdate(e:HyperlinkEvent) {
		var type = e.getEventType();
		if (type == HyperlinkEvent$EventType.ACTIVATED) {
		    var url = e.getDescription();
		    if (not url.startsWith("object;")) {
			(self.onHyperlinkActivated)(url);
		    }
		}
	    }
	});
    jlabel.setFocusable(true);
    jlabel.setOpaque(false);
    if (text <> null) {
        jlabel.setText(text);
        if (jlabel.isFocusable()) {
            jlabel.<<select>>(0, 0);
        }
    }
    jlabel.putClientProperty(jlabel.HONOR_DISPLAY_PROPERTIES,
                             honorDisplayProperties);
    jlabel.setPreloadImages(preloadImages);
    return jlabel;
}



trigger on (Label.text = value) {
    if (jlabel <> null) {
        var c = ++updateCount;
        do later {
             if (c == updateCount) {
                jlabel.setText(value);
                if (jlabel.isFocusable()) {
                    jlabel.<<select>>(0, 0);
                }
             } 
        }
    }
}
