/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.AbstractMenuItem;
import javafx.ui.KeyStroke;
import javafx.ui.MenuItem;
import javafx.ui.MenuSeparator;

public class Menu extends AbstractMenuItem {
    private attribute origrollover: Boolean;
    private attribute origbackground: <<java.awt.Color>>;
    private attribute jmenu:<<javax.swing.JMenu>>;
    public attribute text:String;
    public attribute mnemonic: KeyStroke?;
    public attribute items: AbstractMenuItem*;
}

trigger on (Menu.mnemonic = value) {
    jmenu.setMnemonic(value.id);
}

operation Menu.onSetOpaque(value: Boolean) {
    if (not value) {
        origrollover = jmenu.isRolloverEnabled();
        origbackground = jmenu.getBackground();
        jmenu.setRolloverEnabled(false);
        jmenu.setBackground(new <<java.awt.Color>>(0,0,0,0));
    } else {
        jmenu.setRolloverEnabled(origrollover);
        jmenu.setBackground(origbackground);
    }
}

operation Menu.createComponent() {
    jmenu = new <<javax.swing.JMenu>>();
    jmenu.setOpaque(false);
    if (text <> null) {
        jmenu.setText(text);
    }
    if (mnemonic <> null) {
        jmenu.setMnemonic(mnemonic.id);
    }
    if (opaque <> null and not opaque) {
        jmenu.setRolloverEnabled(false);
        jmenu.setBackground(new <<java.awt.Color>>(0,0,0,0));
    }
    return jmenu;
}

trigger on (Menu.text = value) {
    if (jmenu <> null) {
        jmenu.setText(value);
    }
}

trigger on (insert menuitem into Menu.items) {
    this.getComponent();
    jmenu.add(menuitem.getComponent(), indexof menuitem);
}

trigger on (delete menuitem from Menu.items) {
    jmenu.remove(indexof menuitem);
}

trigger on (Menu.items[oldItem] = newItem) {
    jmenu.remove(indexof oldItem);
    jmenu.add(newItem.getComponent(), indexof newItem);
}
