/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.UIElement;
import javafx.ui.MessageType;
import javafx.ui.Icon;

public class MessageDialog {
    public attribute owner: UIElement?;
    public attribute messageType: MessageType;
    public attribute icon: Icon?;
    public attribute title: String;
    public attribute message: String;
    public attribute visible: Boolean;
    public attribute onClose: operation();
}

attribute MessageDialog.visible = false;
attribute MessageDialog.messageType = PLAIN:MessageType;

trigger on MessageDialog.visible = value {
    if (value) {
        do later {
            <<javax.swing.JOptionPane>>.showMessageDialog(owner.getWindow(),
                                                          message,
                                                          title,
                                                          messageType.id,
                                                          icon.getIcon());
            (this.onClose)();
        }
    }
}
