/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javax.swing.JPopupMenu;
import javax.swing.event.PopupMenuListener;

public class PopupMenu {
    private attribute jpopupMenu: JPopupMenu?;
    public attribute owner: Widget?;
    public attribute items: MenuItem*;
    public attribute x: Number;
    public attribute y: Number;
    public attribute visible: Boolean;
}

trigger on insert item into PopupMenu.items {
    if (jpopupMenu <> null) {
        jpopupMenu.add( item.getComponent(), indexof item);
    }
}

trigger on delete item from PopupMenu.items {
    if (jpopupMenu <> null) {
        jpopupMenu.remove(indexof item);
    }
}

trigger on PopupMenu.items[oldItem] = newItem {
    if (jpopupMenu <> null) {
        jpopupMenu.remove(indexof newItem);
        jpopupMenu.add(newItem.getComponent(), indexof newItem);
    }
}

trigger on PopupMenu.visible = value {
    if (value) {
        if (jpopupMenu == null) {
            jpopupMenu = new JPopupMenu();
            for (i in items) {
                jpopupMenu.add(i.getComponent());
            }
            var self = this;
            jpopupMenu.addPopupMenuListener(new PopupMenuListener() {
                    operation popupMenuWillBecomeVisible(e) {
                    }
                    operation popupMenuWillBecomeInvisible(e) {
                        do later {self.visible = false;}
                    }
                    operation popupMenuCanceled(e) {
                        do later {self.visible = false;}
                    }
                });
        }
        do later {
            jpopupMenu.show(owner.getComponent(), x, y);
        }
    } else {
        jpopupMenu.setVisible(false);
    }
}
