/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

import java.awt.geom.AffineTransform;

public class RadialGradient extends Gradient {
    public attribute cx: Number?;
    public attribute cy: Number?;
    public attribute radius: Number;
    public attribute focusX: Number?;
    public attribute focusY: Number?;
    protected operation createPaint(stopCount:Number,
                                    t:AffineTransform,
                                    cx:Number,
                                    cy:Number,
                                    radius:Number,
                                    focusX:Number,
                                    focusY:Number,
                                    holders:StopHolder*,
                                    spreadMethod:SpreadMethod,
                                    gradientUnits:GradientUnits):<<java.awt.Paint>>;
    protected operation createColor(stopCount:Number,
                                    t:AffineTransform,
                                    cx:Number,
                                    cy:Number,
                                    radius:Number,
                                    focusX:Number,
                                    focusY:Number,
                                    holders:StopHolder*,
                                    spreadMethod:SpreadMethod,
                                    gradientUnits:GradientUnits):<<java.awt.Color>>;
}

attribute RadialGradient.gradientUnits = OBJECT_BOUNDING_BOX;
attribute RadialGradient.spreadMethod = PAD;

function RadialGradient.getPaint() {
   return createPaint(stopCount, affineTransform, cx, cy, radius, focusX, focusY, holders, spreadMethod, gradientUnits);
}

function RadialGradient.getColor() {
   return createColor(stopCount, affineTransform, cx, cy, radius, focusX, focusY, holders, spreadMethod, gradientUnits);
}

operation RadialGradient.createPaint(stopCount:Number,
                                    t:AffineTransform,
                                    cx:Number,
                                    cy:Number,
                                    radius:Number,
                                    focusX:Number,
                                    focusY:Number,
                                    holders:StopHolder*,
                                    spreadMethod:SpreadMethod,
                                    gradientUnits:GradientUnits) {
    var g = new <<net.java.javafx.ui.RadialGradient>>();
    if (affineTransform <> null) {
        g.setTransform(affineTransform);
    }
    g.setGradientUnits(gradientUnits.id);
    g.cx = if cx == null then radius else cx;
    g.cy = if cy == null then radius else cy;
    var fx = if focusX == null then g.cx else focusX;
    var fy = if focusY == null then g.cy else focusY;
    g.focusX = fx;
    g.focusY = fy;
    g.radius = radius;
    g.stops = foreach (s in holders) s.jstop;
    g.spreadMethod = spreadMethod.id;
    return g.getPaint();
}

operation RadialGradient.createColor(stopCount:Number,
                                    t:AffineTransform,
                                    cx:Number,
                                    cy:Number,
                                    radius:Number,
                                    focusX:Number,
                                    focusY:Number,
                                    holders:StopHolder*,
                                    spreadMethod:SpreadMethod,
                                    gradientUnits:GradientUnits) {
    var g = new <<net.java.javafx.ui.RadialGradient>>();
    if (affineTransform <> null) {
        g.setTransform(affineTransform);
    }
    g.setGradientUnits(gradientUnits.id);
    g.cx = if cx == null then radius else cx;
    g.cy = if cy == null then radius else cy;
    var fx = if focusX == null then g.cx else focusX;
    var fy = if focusY == null then g.cy else focusY;
    g.focusX = fx;
    g.focusY = fy;
    g.radius = radius;
    g.stops = foreach (s in holders) s.jstop;
    g.spreadMethod = spreadMethod.id;
    return g;
}
