/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.MenuItem;
import javafx.ui.SelectableButton;

public class RadioButtonMenuItem extends MenuItem, SelectableButton {
    private attribute jradiobuttonmenuitem:<<javax.swing.JRadioButtonMenuItem>>;
}

trigger on (new RadioButtonMenuItem) {
    jradiobuttonmenuitem = new <<javax.swing.JRadioButtonMenuItem>>();
}

operation RadioButtonMenuItem.createMenuItem() {
    var self = this;
    jradiobuttonmenuitem.addChangeListener(new <<javax.swing.event.ChangeListener>>() {
                                            operation stateChanged(e) {
                                                var i = select indexof x from x in self.buttonGroup.buttons where x == self;
                                                do later {
						    if (self.selected == self.jradiobuttonmenuitem.isSelected()) {
							//return;
						    }
                                                    self.selected = self.jradiobuttonmenuitem.isSelected();
                                                    if (self.onChange <> null) {
                                                         (self.onChange)(self.selected);
                                                    }
                                                    if (self.selected) {
                                                        self.buttonGroup.selection = i[0];
                                                    }
                                                }
                                            }
                                        });
    return jradiobuttonmenuitem;
}

operation RadioButtonMenuItem.setSelected(value:Boolean) {
    jradiobuttonmenuitem.setSelected(value);
}
