/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

import javax.swing.JViewport;
import java.awt.LayoutManager2;
import javax.swing.JPanel;
import java.awt.Dimension;
import net.java.javafx.ui.LayoutNotifier;
import java.lang.Math;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetListener;
import javax.swing.JViewport;
import java.awt.BorderLayout;
import net.java.javafx.ui.ScrollablePanel;
import javafx.ui.TabSlider;

public class SlideTab {
    // private
    private attribute scrollable: ScrollablePanel;
    private attribute viewport: JViewport;
    private attribute size: Number;
    private attribute slider: TabSlider;


    // public
    public attribute enabled: Boolean;
    public attribute button: Widget?;
    public attribute title: String?;
    public attribute toolTipText: String?;
    public attribute icon: Icon?;
    public attribute content: Widget;
    public attribute selected: Boolean;
    public attribute opaque: Boolean;
}

attribute SlideTab.enabled = true;
attribute SlideTab.opaque = true;

trigger on (SlideTab.enabled = value) {
    button.enabled = value;
}

trigger on (SlideTab.opaque = value) {
    button.opaque = value;
}

trigger on (SlideTab.title = newValue) {
    if (button instanceof Button) {
        ((Button)button).text = newValue;
    }
}

trigger on (SlideTab.toolTipText = newValue) {
    if (button instanceof Button) {
        ((Button)button).toolTipText = newValue;
    }
}

trigger on (SlideTab.icon = newValue) {
    if (button instanceof Button) {
        ((Button)button).icon = newValue;
    }
}
