/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

public class Spinner extends Widget {
    protected attribute spinner:<<javax.swing.JSpinner>>;
    public attribute min: Number?;
    public attribute max: Number?;
    public attribute value: Number;
    public attribute stepSize: Number?;
    public attribute onChange: function(value:Number);
    public attribute editorForeground: Color?;
    public attribute editorBackground: Color?;
    public attribute editorFont: Font?;
}

attribute Spinner.focusable = false;

trigger on Spinner.editorForeground = value {
    var comp = spinner.getEditor();
    if (comp instanceof <<javax.swing.JSpinner$DefaultEditor>>) {
        var def = (<<javax.swing.JSpinner$DefaultEditor>>)comp;
        def.getTextField().setForeground(value.getColor());
    }
}

trigger on Spinner.editorBackground = value {
    var comp = spinner.getEditor();
    if (comp instanceof <<javax.swing.JSpinner$DefaultEditor>>) {
        var def = (<<javax.swing.JSpinner$DefaultEditor>>)comp;
        def.getTextField().setBackground(value.getColor());
    }
}

trigger on Spinner.editorFont = value {
    var comp = spinner.getEditor();
    if (comp instanceof <<javax.swing.JSpinner$DefaultEditor>>) {
        var def = (<<javax.swing.JSpinner$DefaultEditor>>)comp;
        def.getTextField().setFont(value.getFont());
    }
}

operation Spinner.createComponent():<<javax.swing.JComponent>> {
    return spinner;
}

trigger on (new Spinner) {
    spinner = context:<<net.java.javafx.ui.UIContext>>.createSpinner();
    var self = this;
    spinner.addChangeListener(new <<javax.swing.event.ChangeListener>>() {
                                  operation stateChanged(e:<<javax.swing.event.ChangeEvent>>) {
                                      self.value = (Number)self.spinner.getValue();
                                      (self.onChange)((Number)self.spinner.getValue());
                                  }
                              });
}

trigger on (Spinner.value = n) {
    if (n <> null) {
        spinner.setValue(n);
    }
}

trigger on (Spinner.min = value) {
        ((<<net.java.javafx.ui.BigDecimalSpinnerModel>>)spinner.getModel()).setMinimum(value);
}

trigger on (Spinner.max = value) {
        ((<<net.java.javafx.ui.BigDecimalSpinnerModel>>)spinner.getModel()).setMaximum(value);
}

trigger on (Spinner.stepSize = value) {
        ((<<net.java.javafx.ui.BigDecimalSpinnerModel>>)spinner.getModel()).setStepSize(value);
}
