/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;

/**
 * Romain Guy's StackLayout: layous out its content on top of each other
 */

public class StackPanel extends Widget {
    private attribute jpanel: <<javax.swing.JPanel>>;
    public attribute content: Widget*;
}

attribute StackPanel.focusable = false;

operation StackPanel.createComponent() {
    jpanel = new <<javax.swing.JPanel>>();
    jpanel.setLayout(new <<net.java.javafx.ui.StackLayout>>());
    jpanel.setOpaque(false);
    jpanel.setCursor(null);
    for (i in content) {
        jpanel.add(i.getComponent());
    }
    return jpanel;
}

trigger on (insert w into StackPanel.content) {
    if (jpanel <> null) {
        jpanel.add(w.getComponent(), indexof w);
        jpanel.validate();
    }
}

trigger on (StackPanel.content[old] = w) {
    if (jpanel <> null) {
        jpanel.remove(indexof w);
        jpanel.add(w.getComponent(), indexof w);
        jpanel.validate();
    }
}

trigger on (delete w from StackPanel.content) {
    if (jpanel <> null) {
        jpanel.remove(indexof w);
        jpanel.validate();
    }
}
