/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.TabbedPane;
import javafx.ui.Widget;
import javafx.ui.Icon;
import java.awt.Dimension;

public class Tab {
    protected attribute tabbedPane: TabbedPane;
    private attribute panel: <<javax.swing.JPanel>>;
    operation selectTab();

    public attribute toolTipText: String?;
    public attribute icon: Icon?;
    public attribute title: String;
    public attribute content: Widget;
    public attribute preferredSize: Dimension?;
}

trigger on (Tab.preferredSize = value) {
    if (value <> null) {
	panel.setPreferredSize(value);
    }
}


trigger on (Tab.title = value) {
    var i = select indexof x from x in tabbedPane.tabs where x == this;
    tabbedPane.tabbedpane.setTitleAt(i, value);
}

trigger on (Tab.icon = value) {
    if (tabbedPane <> null) {
        var i = select indexof x from x in tabbedPane.tabs where x == this;
        var icon:<<javax.swing.Icon>> = null;
        if (value <> null) {
            icon = value.getIcon();
        }
        tabbedPane.tabbedpane.setIconAt(i, icon);
    }
}


trigger on (new Tab) {
    panel = new <<javax.swing.JPanel>>();
    panel.setOpaque(false);
    panel.setLayout(new <<java.awt.BorderLayout>>());
}

trigger on (Tab.content = widget) {
    if (tabbedPane <> null) {
        if (panel.getComponentCount() > 0) {
            panel.remove(0);
        }
        panel.add(widget.getComponent(), <<java.awt.BorderLayout>>.CENTER);
    }
}

operation Tab.selectTab() {
    if (content <> null and panel.getComponentCount() == 0) {
        panel.add(content.getComponent(),
                  <<java.awt.BorderLayout>>.CENTER);
        panel.getParent().validate();
    }
}
