/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.Cursor;
import java.awt.Point;
import java.awt.Toolkit;
import javafx.ui.Canvas;
import java.lang.System;

public class CanvasCursor extends Cursor {
    private attribute canvas: Canvas;

    public attribute content: Node?;
    public attribute x: Number;
    public attribute y: Number;
}

operation CanvasCursor.createCursor() {
    if (canvas == null) {
        canvas = Canvas { content: this.content };
    }
    canvas.getComponent();
    var dim = canvas.zcanvas.getPreferredSize();
    canvas.zcanvas.setBounds(0, 0, dim.width, dim.height);
    var im = canvas.zcanvas.getIconImage();
    return Toolkit.getDefaultToolkit().createCustomCursor(im, new Point(x, y), "{System.identityHashCode(this)}");
}

