/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.XY;
import net.java.javafx.jazz.event.ZMouseEvent;
import javafx.ui.KeyModifier;

public class CanvasMouseEvent {
    public attribute modifiers: KeyModifier*;
    public attribute clickCount: Number;
    public attribute button: Integer;
    public attribute localX: Number;
    public attribute localY: Number;
    public attribute x: Number;
    public attribute y: Number;
    public attribute screenx: Number;
    public attribute screeny: Number;
    public attribute dragTranslation: XY?;
    public attribute localDragTranslation: XY?;
    public attribute percolate: Boolean;
    public function isControlDown():Boolean;
    public function isAltDown():Boolean;
    public function isShiftDown():Boolean;
    public function isMetaDown():Boolean;
    public function isPopupTrigger():Boolean;
    protected attribute source: ZMouseEvent;
}

function CanvasMouseEvent.isControlDown() {
    return CTRL:KeyModifier in modifiers;
}

function CanvasMouseEvent.isShiftDown() {
    return SHIFT:KeyModifier in modifiers;
}

function CanvasMouseEvent.isMetaDown() {
    return META:KeyModifier in modifiers;
}

function CanvasMouseEvent.isAltDown() {
    return ALT:KeyModifier in modifiers;
}

function CanvasMouseEvent.isPopupTrigger() {
    return source.isPopupTrigger();
}

trigger on CanvasMouseEvent.percolate = value {
    source.percolate = value;
}
