/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.*;

public class HBox extends CompositeNode {
    private attribute holders: Group*;
    public attribute content: Node*;
}

attribute HBox.holders = 
  bind foreach (t in content)
     Group {
          var: self
          content: t
          var prev = if indexof t > 0 and self.hasParent() 
                         then holders[indexof t-1] else null
          var x = if prev == null 
                    then 0 else prev.currentX + prev.currentWidth
          transform: bind translate(x, 0)
     }

;

function HBox.composeNode() = 
    Group {
        content: bind holders
    }
;
