/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.PathElement;
import java.awt.geom.GeneralPath;

/**
 * Draws a horizontal line from the current point to x.
 */

public class HLine extends PathElement {
    public attribute x: Number;
}

trigger on HLine.x = value {
    path.buildPath();
}

operation HLine.addTo(gp:GeneralPath) {
    if (absolute) {
    	path.currentX = x;
    	path.yCenter = path.currentY;
    	
        var y = gp.getCurrentPoint().y;
        for (i in x) {
            gp.lineTo(i, y);
        }
    } else {
    	path.currentX += x;
    	path.xCenter = path.currentX;
    	path.yCenter = path.currentY;

        var pt = gp.getCurrentPoint();
        var prev = pt.x;
        var y = pt.y;
        for (i in x) {
            gp.lineTo(prev+i, y);
            prev = i;
        }
    }
}
