/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Node;
import net.java.javafx.jazz.ZLayoutGroup;

class Layout extends Node {
    attribute layoutgroup: ZLayoutGroup;
    attribute content: Node*;
    ...
}

trigger on insert c into Layout.content {
    c.parentCanvasElement = this;
    if (layoutgroup <> null) {
        layoutgroup.addChild(indexof c, c.getNode());
        layoutgroup.validate();
    }
}

trigger on Layout.content[oldValue] = newValue {
    newValue.parentCanvasElement = this;
    if (layoutgroup <> null) {
        layoutgroup.removeChild(indexof oldValue);
        layoutgroup.addChild(indexof newValue, newValue.getNode());
        layoutgroup.validate();
    }
}

trigger on delete c from Layout.content {
    if (layoutgroup <> null) {
        layoutgroup.removeChild(indexof c);
        layoutgroup.validate();
    }
}
