/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.PathElement;
import java.awt.geom.GeneralPath;

/**
 * Adds a point to the path by drawing a straight line from the
 * current coordinates to the new specified coordinates (x, y).
 */

public class LineTo extends PathElement {
    /** the x coordinate of the point */
    public attribute x: Number;
    /** the y coordinate of the point */
    public attribute y: Number;
}

trigger on LineTo.x = value {
    path.buildPath();
}

trigger on LineTo.y = value {
    path.buildPath();
}

operation LineTo.addTo(gp:GeneralPath) {
    if (absolute) {
    	path.currentX = x;
    	path.xCenter = path.currentX;
    	
    	path.currentY = y;
    	path.yCenter = path.currentY;
    	
        gp.lineTo(x, y);
    } else {
    	path.currentX += x;
    	path.xCenter = path.currentX;
    	
    	path.currentY += y;
    	path.yCenter = path.currentY;
    
        var pt = gp.getCurrentPoint();
        gp.lineTo(pt.x + x, pt.y + y);
    }
}
