package javafx.ui.canvas;
import net.java.javafx.ui.Morphing2D;
import net.java.javafx.jazz.component.ZShape;
import java.awt.Shape as AWTShape;
import javafx.ui.canvas.Shape;
import javafx.ui.Color;
import javafx.ui.Paint;

public class Morph extends Shape {
    public attribute start: Shape?;
    public attribute end: Shape?;
    public attribute morph: Number;
    private attribute zmorph: ZShape?;
    private attribute morphing2D: Morphing2D?;
    private attribute awtStartShape: AWTShape?;
    private attribute awtEndShape: AWTShape?;
    private attribute fill1: Paint?;
    private attribute fill2: Paint?;
    private operation updateMorphing2D();
    private operation updateFill();
}

attribute Morph.awtStartShape = bind start.getTransformedShape();
attribute Morph.awtEndShape = bind end.getTransformedShape();
attribute Morph.fill1 = bind start.fill;
attribute Morph.fill2 = bind end.fill;

operation Morph.createShape() {
    zmorph = new ZShape();
    updateMorphing2D();
    return zmorph;
}

trigger on Morph.fill1 = value {
    updateFill();
}

trigger on Morph.fill2 = value {
    updateFill();
}

trigger on Morph.morph = newValue {
    zmorph.setShape(null);
    morphing2D.setMorphing(morph);
    zmorph.setShape(morphing2D);
    updateFill();
}

operation Morph.updateFill() {
    var fill1 = start.fill;
    var fill2 = end.fill;
    if ((fill1 instanceof Color) and (fill2 instanceof Color)) {
	var c1 = (Color)fill1;
	var c2 = (Color)fill2;
	fill = c1.interpolate(c2, morph);
    }
}

trigger on Morph.awtStartShape = value {
    updateMorphing2D();
}

trigger on Morph.awtEndShape = value {
    updateMorphing2D();
}

operation Morph.updateMorphing2D() {
    if (awtStartShape <> null and awtEndShape <> null) {
	morphing2D = new Morphing2D(awtStartShape, awtEndShape);
	morphing2D.setMorphing(morph);
	if (zmorph <> null) {
	    zmorph.setShape(morphing2D);
	}
    }
}
