package javafx.ui.canvas;
import net.java.javafx.ui.Morphing2D;
import net.java.javafx.jazz.component.ZShape;
import java.awt.Shape as AWTShape;
import javafx.ui.canvas.Shape;

class MorphElement {
    public attribute time: Number;
    public attribute shape: Shape?;
    public attribute x1: Number;
    public attribute y1: Number;
    public attribute x2: Number;
    public attribute y2: Number;
}

attribute MorphElement.x2 = 1;
attribute MorphElement.y2 = 1;

public class Morph extends Shape {
    public attribute content: MorphElement*;
    public attribute morph: Number;
    private attribute zmorph: ZShape?;
    private attribute morphing2D: Morphing2D?;
    private attribute awtStartShape: AWTShape?;
    private attribute awtEndShape: AWTShape?;
    private operation updateMorphing2D();
}

attribute Morph.awtStartShape = bind start.getTransformedShape();
attribute Morph.awtEndShape = bind end.getTransformedShape();

operation Morph.createShape() {
    zmorph = new ZShape();
    if (morphing2D <> null) {
	morphing2D.setMorphing(morph);
	zmorph.setShape(morphing2D);
    }
    return zmorph;
}

trigger on Morph.morph = newValue {
    zmorph.setShape(null);
    morphing2D.setMorphing(morph);
    zmorph.setShape(morphing2D);
}

trigger on Morph.awtStartShape = value {
    updateMorphing2D();
}

trigger on Morph.awtEndShape = value {
    updateMorphing2D();
}

operation Morph.updateMorphing2D() {
    if (awtStartShape <> null and awtEndShape <> null) {
	morphing2D = new Morphing2D(awtStartShape, awtEndShape);
	morphing2D.setMorphing(morph);
	if (zmorph <> null) {
	    zmorph.setShape(morphing2D);
	}
    }
}
