/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.ZPolygon;

/** 
 * Draws a closed polygon defined by a sequence of points [x1, y1, x2, y2,..., xN, yN].
 * The figure is automatically closed by drawing a line connecting
 * the final point to the first point, if those points are different.
 */
public class Polygon extends Shape {
    private attribute zpolygon: ZPolygon;
    /** The list of points that define this polygon */
    public attribute points: Number*;
}

trigger on insert pt into Polygon.points {
    //fix me: OPT
    if (zpolygon <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolygon.setCoords(xs, ys);
        }
    }
}

trigger on Polygon.points[oldValue] = newValue {
    //fix me: OPT
    if (zpolygon <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolygon.setCoords(xs, ys);
        }
    }
}


trigger on delete pt from Polygon.points {
    //fix me: OPT
    if (zpolygon <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolygon.setCoords(xs, ys);
        }
    }
}

operation Polygon.createShape() {
    var xs = points[p|indexof p % 2 == 0];
    var ys = points[p|indexof p % 2 <> 0];
    zpolygon = new ZPolygon(0,0);
    zpolygon.setCoords(xs, ys);
    return zpolygon;
}
