/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.*;
/** 
  * A shape consisting of multiple attached line segments defined by a
  * sequence of points (points) <br></br>[x1, y1, x2, y2, ..., xN, yN].
  */
public class Polyline extends Shape {

    private attribute zpolyline: ZPolyline;

    /**
     *  The list of points that make up this polyline. These are alternating
     *  x and y coordinates.
     */
    public attribute points: Number*;
}

trigger on insert pt into Polyline.points {
    //fix me: OPT
    if (zpolyline <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolyline.setCoords(xs, ys);
        }
    }
}

trigger on Polyline.points[oldValue] = newValue {
    //fix me: OPT
    if (zpolyline <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolyline.setCoords(xs, ys);
        }
    }
}


trigger on delete pt from Polyline.points {
    //fix me: OPT
    if (zpolyline <> null) {
        if (sizeof points % 2 == 0) {
            var xs = points[p|indexof p % 2 == 0];
            var ys = points[p|indexof p % 2 <> 0];
            zpolyline.setCoords(xs, ys);
        }
    }
}

operation Polyline.createShape() {
    var xs = points[p|indexof p % 2 == 0];
    var ys = points[p|indexof p % 2 <> 0];
    zpolyline = new ZPolyline();
    if (sizeof xs > 0 and sizeof ys > 0) {
        zpolyline.setCoords(xs, ys);
    }
    return zpolyline;
}
