/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.ZQuadCurve;

/**
 * The <code>QuadCurve</code> class defines a quadratic parametric curve
 * segment by means of a start point (x1, y1), a control point (ctrlx, ctrly), 
 * and an end point (x2, y2).
 */

public class QuadCurve extends Shape {

    private attribute zquadCurve: ZQuadCurve;


    /** The x coordinate of the start point of this quad curve. */
    public attribute x1: Number;
    /** The y coordinate of the start point of this quad curve. */
    public attribute y1: Number;
    

    /** The x coordinate of the control point of this quad curve. */
    public attribute ctrlx: Number;
    /** The y coordinate of the control point of this quad curve. */
    public attribute ctrly: Number;

    /** The x coordinate of the end point of this quad curve. */
    public attribute x2: Number;
    /** The y coordinate of the end point of this quad curve. */
    public attribute y2: Number;
}

operation QuadCurve.createShape() {
    zquadCurve = new ZQuadCurve(x1, y1, ctrlx, ctrly, x2, y2);
    return zquadCurve;
}

trigger on QuadCurve.x1 = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}

trigger on QuadCurve.y1 = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}

trigger on QuadCurve.ctrlx = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}

trigger on QuadCurve.ctrly = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}

trigger on QuadCurve.x2 = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}

trigger on QuadCurve.y2 = newValue {
    if (zquadCurve <> null) {
	zquadCurve.setCurve(x1, y1, ctrlx, ctrly, x2, y2);
    }
}
