/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
/**
 * Interface for rectangular elements which can be sized by
 * their height and width.
 */
public class SizeableCanvasElement extends CanvasElement {
    /** If true this element will be sized to the dimensions of its containing canvas */
    public attribute sizeToFitCanvas: Boolean;
    /** Sets the size of this element to (width, height). */
    public operation setSize(width: Number, height: Number);
    protected operation onSizeToFitCanvas(value:Boolean);
    ...
}

trigger on SizeableCanvasElement.sizeToFitCanvas = value{
    this.onSizeToFitCanvas(value);
}
