/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import java.awt.geom.AffineTransform;
import java.lang.Math;

/**
 * Transformation operation which skews an object.  
 */
public class Skew extends Transform {
    /** The skew angle along the x axis in degrees */
    public attribute x: Number;
    /** The skew angle along the y axis in degrees*/
    public attribute y: Number;
}

trigger on Skew.x = value {
    transform = AffineTransform.getShearInstance(Math.tan(Math.toRadians(x)),
                        Math.tan(Math.toRadians(y)));
}

trigger on Skew.y = value {
    transform = AffineTransform.getShearInstance(Math.tan(Math.toRadians(x)),
                        Math.tan(Math.toRadians(y)));
}

skew:Skew = operation(x:Number,y:Number) {
    return Skew {x: x, y: y};
};

skewX:Skew = operation(x:Number) {
    return Skew {x: x, y: 0};
};

skewY:Skew = operation(y:Number) {
    return Skew {x: 0, y: y};
};


