/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.PathElement;
import java.awt.geom.GeneralPath;

/**
 * Draws a vertical line from the current point to y.
 */

public class VLine extends PathElement {
    public attribute y: Number;
}

trigger on VLine.y = value {
    path.buildPath();
}

operation VLine.addTo(gp:GeneralPath) {
    if (absolute) {
    	path.xCenter = path.currentX;
    	path.currentY = y;
    	path.yCenter = path.currentY;
    	
        var x = gp.getCurrentPoint().x;
        for (i in y) {
            gp.lineTo(x, i);
        }
    } else {
    	path.xCenter = path.currentX;
    	path.currentY += y;
    	path.yCenter = path.currentY;
    	
        var pt = gp.getCurrentPoint();
        var prev = pt.y;
        var x = pt.x;
        for (i in y) {
            gp.lineTo(x, prev + i);
            prev = i;
        }
    }
}
