/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.Filter;
import javafx.ui.filter.EdgeAction;
import com.jhlabs.image.ConvolveFilter as JHConvolveFilter;

public class ConvolveFilter extends Filter {
    protected attribute convolveFilter: JHConvolveFilter;
    public attribute edgeAction: EdgeAction?;
    protected operation createConvolveFilter(): JHConvolveFilter;
    ...
}

operation ConvolveFilter.createFilter() {
    if (convolveFilter == null) {
        convolveFilter = this.createConvolveFilter();
        if (edgeAction <> null) {
            convolveFilter.setEdgeAction(edgeAction.id);
        }
    }
    return convolveFilter;
}
