/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.Filter;
import com.jhlabs.image.TextureFilter as JHTextureFilter;

public class TextureFilter extends Filter {
    protected attribute textureFilter: JHTextureFilter;
    public attribute amount: Number;
    public attribute scale: Number;
    public attribute stretch: Number;
    public attribute gain: Number;
    public attribute bias: Number;
    public attribute turbulence: Number;
    protected operation createTextureFilter(): JHTextureFilter;
}

attribute TextureFilter.amount = 1.0;
attribute TextureFilter.stretch = 1.0;
attribute TextureFilter.scale = 32;
attribute TextureFilter.turbulence = 1.0;
attribute TextureFilter.gain = 0.5;
attribute TextureFilter.bias = 0.5;

operation TextureFilter.createTextureFilter() {
    return new JHTextureFilter();
}

operation TextureFilter.createFilter() {
    if (textureFilter == null) {
        textureFilter = createTextureFilter();
        textureFilter.amount = amount;
        textureFilter.scale = scale;
        textureFilter.stretch = stretch;
        textureFilter.bias = bias;
        textureFilter.gain = gain;
    }
    return textureFilter;
}
